# Elcut       coil.pbm.


package require twapi;
twapi::import_commands;


#===============================================
#   Elcut
#===============================================
proc getELCForceX {x_position} {
#0.  
#1.   ,  
#2.  
	

# 0.  
	set ELC [comobj ELCUT.Application];	# Elcut
    set pbm [[$ELC Problems] Item 1];	#    
    $pbm LoadModel; 					# 
    set mdl [$pbm Model];				# 
	
#1.      x,   "R" 
	set theVertex [[[[$mdl Shapes] Vertices] LabeledAs "R" "" ""] Item 1];
    set theXposition [[$theVertex Point] X];	# x-  "R"
    set theVector [$ELC PointXY [expr $x_position - $theXposition] 0];	#  
#   2- : "" (), "" ()
#i   ,      
    set theBlock [[[[$mdl Shapes] Blocks] LabeledAs "" "" ""] Item 1];	#  ""	
    $theBlock Move 0 $theVector;		# . 0=qfShift, 



#2.  
    [$mdl Shapes] BuildMesh true false;	# 
    $mdl Save;				# 
    if {[$pbm Solved]!=1} {		#,   
        $pbm SolveProblem;		#solve problem
		};
    $pbm AnalyzeResults;		# 
    set res [$pbm Result];		#   
    

    set theFieldWindow [$res GetFieldWindow 1];	#   
    set theContour [$theFieldWindow Contour];	#  
#   2- : "" (), "" ()
    $theContour AddBlock1 "";		#    ""
    $theContour AddBlock1 "";		#   a ""

#   
    set theForce [[$res GetIntegral 15 $theContour] Value]; #15=qfInt_MaxwellForce
	return [$theForce X]; 				    # x- 
	}

	
	
	

#===============================================
#    
#===============================================

#  
set x_out 0.01;       			#   , 
set x_in 0.006;       			#   , 
set m_mass 0.0045;     		#  , 
set k 4.0;            			#   , /
set x_spring_free 0.015;  		#    , 


# 
set t_time 0.0;    		# , 
set x_position $x_out;  	#  , 
set v_speed 0.0;         	#  , /


set dt_time_step 0.005;	#  , 
set max_time 0.2;        	#   


puts ",	,	,/";

while { $t_time < $max_time && $x_position > $x_in } {
	set theForce [getELCForceX $x_position];					#  
    set theForce [expr $theForce + ($x_spring_free - $x_position) * $k];	#   
    set v_speed [expr $v_speed +  ($theForce / $m_mass) * $dt_time_step]; 	#    
    set x_position [expr $x_position + $v_speed * $dt_time_step];		#   
	set t_time [expr $t_time + $dt_time_step];				#  
	puts "$t_time	$x_position	$v_speed";				#  
	};